/*
 *  $Header: /auto/nfs/sequoia/u/home/rws/pextk/src/pextk_protos.h,v 1.1 1993/10/12 00:07:43 rws Exp $
 ******************************************************************************
 ******************************************************************************
 *****                         pextk_protos.h                             *****
 *****									  *****
 *****		    An Immediate Mode Interface to PEX			  *****
 *****									  *****
 *****									  *****
 *****     This module contains the function definitions to internal      *****
 *****	   modules of pextk.						  *****
 *****									  *****
 *                                                                            *
 *	Copyright 1992, 1993. All Rights Reserved                             *
 *			SHOgraphics					      *
 *			321 Soquel Way           			      *
 *			Sunnyvale, CA     94086   			      *
 *                                                                            *
 *****									  *****

    Permission to use, copy, modify, and distribute this software and
 its documentation for any purpose and without fee is hereby granted,
 provided that the above copyright notice appear in all copies and that
 both that copyright notice and this permission notice appear in
 supporting documentation, and that the names of SHOgraphics,
 the X Consortium, and MIT not be used in advertising or publicity
 pertaining to distribution of the software without specific, written
 prior permission.

 SHOGRAPHICS DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 INCLUDING ALL EXPRESSED AND IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS. IN NO EVENT SHALL SHOGRAPHICS BE LIABLE FOR ANY DAMAGES OF ANY
 KIND, INCLUDING BUT NOT LIMITED TO SPECIAL, INDIRECT OR CONSEQUENTIAL 
 DAMAGES RESULTING FROM LOSS OF USE, DATA OR PROSPECTIVE PROFITS, WHETHER 
 IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS ACTION, ARISING OUT 
 OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

 ************************************************************************ */


	/*
	 * Routines to perform special operations
	 */
	int		PEXtk_init_buf();
	int		PEXtk_init_bld();
	int		PEXtk_init_cmap();
	int		PEXtk_init_db();
	int		PEXtk_init_dls();
	int		PEXtk_init_mtx();
	int		PEXtk_init_pck();
	int		PEXtk_init_pex();
	int		PEXtk_init_utl();
	int		PEXtk_init_vue();
	int		PEXtk_close_db();
	int		PEXtk_close_dls();
	int		PEXtk_close_utl();
	int		PEXtk_FreeColormap();
	int		PEXtk_Get_Visuals();
	int		PEXtk_check_poly_attrib();
	int		PEXtk_SetColorTable();

	int		PEXtk_create_back_pixmap();
	int		PEXtk_delete_back_pixmap();
	int		PEXtk_create_mbuf();
	int		PEXtk_delete_mbuf();
	int		PEXtk_copy_window();
	int		PEXtk_swap_mbuf();
	int		PEXtk_create_es_dblbuf();
	int		PEXtk_delete_es_dblbuf();
	int		PEXtk_swap_es_dblbuf();
	int		PEXtk_mpex_clear_z();
	int		PEXtk_mpex_clear_iz();
	int		PEXtk_mpex_clear_i();
	int		PEXtk_clear_z();
	int		PEXtk_clear_z_5();
	int		PEXtk_transparency();
	int		PEXtk_antialias();
	int		PEXtk_dither();
	int		PEXtk_mpex_reset_state();
	int		PEXtk_clear_area();
	int		PEXtk_clear_none();
	int		PEXtk_clear_iz();
	int		PEXtk_clear_i();
	int		PEXtk_clear_iz_5();
	int		PEXtk_clear_i_5();
	int		PEXtk_surface_color();
	int		PEXtk_hiddenline_color();
	int		PEXtk_surface_color_ind();
	int		PEXtk_hiddenline_color_ind();
	int		PEXtk_default();

	int		PEXtk_matrix_copy();
	int		PEXtk_matrix_tcopy();
	int		PEXtk_set_viewport();
	int		PEXtk_concat();
	int		PEXtk_preconcat();
	int		PEXtk_concat_struct();
	int		PEXtk_preconcat_struct();

	int		PEXtk_reset_pex_state(
#if PEXtk_PROTOTYPES
	int		/* i */,
	long		/* mask */
#endif
);
	extern int	PEXtk_create_all_id(
#if PEXtk_PROTOTYPES
	int		/* i */,
	Window		/* buf */
#endif
);
	extern int	PEXtk_copy_all_id(
#if PEXtk_PROTOTYPES
	int		/* src */,
	int		/* i */
#endif
);

	/*
	 * database routines
	 */
	extern int	DB_add_label_list();
	extern int	DB_check_poly_attrib();
	extern int	DB_check_bld_vert();
	extern int	DB_check_bld_color();
	extern int	DB_check_bld_normal();
	extern int	DB_check_bld_counts();
	extern int	DB_check_bld_poly_point();
	extern int	DB_check_bld_polynorm();
	extern int	DB_check_build_mask();
	extern int	DB_check_build_buffer_size();
	extern int	DB_check_dirty_mask();
	extern int	DB_check_indicies_size();
	extern int	DB_check_poly_count_list();
	extern int	DB_check_struct_list();
	extern int	DB_close_db();
	extern int	DB_delete_struct_name();
	extern int	DB_find_dls_name();
	extern int	DB_find_label_name();
	extern int	DB_find_struct_name();
	extern int	DB_free_struct_list();
	extern int	DB_get_color_values();
	extern char *	DB_get_bld_type_string();
	extern int	DB_init_bld_counts();
	extern int	DB_insert_color_values();
	extern int	DB_insert_struct_name();

	/*
	 * DLS routines
	 */
	extern int	DLS_create_dpy_list(
#if PEXtk_PROTOTYPES
	int		/* name */
#endif
);
	extern int	DLS_delete_dpy_list(
#if PEXtk_PROTOTYPES
	int		/* name */
#endif
);
	extern int	DLS_call_dpy_list(
#if PEXtk_PROTOTYPES
	int		/* name */
#endif
);
	extern int	DLS_add_view(
#if PEXtk_PROTOTYPES
	PEXtk_VIEW*	/* view */
#endif
);
	extern int	DLI_call_dls(
#if PEXtk_PROTOTYPES
	DPY_LIST_NODE*	/* ptr */
#endif
);
	extern int	DLI_display(
#if PEXtk_PROTOTYPES
	int		/* name */
#endif
);
	extern int	DLS_call_dls(
#if PEXtk_PROTOTYPES
	int		/* name */
#endif
);
	extern int	DLS_xform(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	int		/* flag */,
	float		/* arg1 */,
	float		/* arg2 */,
	float		/* arg3 */
#endif
);
	extern int	DLS_rot_vector(
#if PEXtk_PROTOTYPES
	float		/* ox */,
	float		/* oy */,
	float		/* oz */,
	float		/* vx */,
	float		/* vy */,
	float		/* vz */,
	Angle		/* a  */,
	int		/* flag */
#endif
);
	extern int	DLS_view_box(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	int		/* arg1 */,
	int		/* arg2 */,
	int		/* arg3 */,
	int		/* arg4 */
#endif
);

	extern int	DLS_view_proj(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	int		/* id   */,
	float		/* arg1 */,
	float		/* arg2 */,
	float		/* arg3 */,
	float		/* arg4 */,
	float		/* arg5 */,
	float		/* arg6 */
#endif
);
	extern int	DLS_view_lookat(
#if PEXtk_PROTOTYPES
	float		/* vx */,
	float		/* vy */,
	float		/* vz */,
	float		/* px */,
	float		/* py */,
	float		/* pz */,
	Angle		/* twist */
#endif
);
	extern int	DLS_view_polar(
#if PEXtk_PROTOTYPES
	float		/* dist */,
	float		/* azim */,
	float		/* inc  */,
	Angle		/* twist */
#endif
);
	extern int	DLS_view_mode(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	int		/* id   */,
	float		/* arg1 */,
	float		/* arg2 */,
	float		/* arg3 */
#endif
);
	extern int	DLS_state(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	int		/* arg1 */
#endif
);
	extern int	DLS_set_drawable(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	long		/* arg1 */
#endif
);
	extern int	DLS_exec(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	int		/* arg1 */
#endif
);
	extern int	DLS_attrib(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	int		/* arg1 */
#endif
);
	extern int	DLS_attrib_f(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	float		/* arg1 */
#endif
);
	extern int	DLS_matrix(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	Matrix		/* mat */,
	int		/* arg1 */,
	int		/* arg2 */
#endif
);
	extern int	DLS_dither(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	int		/* arg1 */,
	int		/* arg2 */
#endif
);
	extern int	DLS_transparency(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	int		/* arg1 */,
	float		/* arg2 */
#endif
);
	extern int	DLS_poly(
#if PEXtk_PROTOTYPES
	int		/* op  */,
	int		/* n   */,
	Fcoord3D*	/* pts */
#endif
);
	extern int	DLS_attrib_text(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	float		/* arg1 */,
	float		/* arg2 */
#endif
);
	extern int	DLS_text(
#if PEXtk_PROTOTYPES
	int		/* op  */,
	float		/* x   */,
	float		/* y   */,
	float		/* z   */,
	char*		/* str */
#endif
);
	extern int	DLS_attrib_clr(
#if PEXtk_PROTOTYPES
	int		/* op  */,
	PCOLOR*		/* col */
#endif
);
	extern int	DLS_attrib_clr_ind(
#if PEXtk_PROTOTYPES
	int		/* op  */,
	int		/* ind */
#endif
);
	extern int	DLS_attrib_clr_3f(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	float		/* arg1 */,
	float		/* arg2 */,
	float		/* arg3 */
#endif
);
	extern int	DLS_bld(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	float		/* arg1 */,
	float		/* arg2 */,
	float		/* arg3 */,
	float		/* arg4 */
#endif
);
	extern int	DLS_stack(
#if PEXtk_PROTOTYPES
	int		/* op  */
#endif
);
	extern int	DLS_name_stack(
#if PEXtk_PROTOTYPES
	int		/* op  */,
	int		/* val */
#endif
);
	extern int	DLS_light(
#if PEXtk_PROTOTYPES
	int		/* n   */,
	PEXtk_LIGHT*	/* lgt */
#endif
);
	extern int	DLS_light_ambient(
#if PEXtk_PROTOTYPES
	float		/* amb */
#endif
);
	extern int	DLS_refl_prop(
#if PEXtk_PROTOTYPES
	float		/* arg1 */,
	float		/* arg2 */
#endif
);
	extern int	DLS_ext(
#if PEXtk_PROTOTYPES
	int		/* op   */,
	unsigned long	/* arg1 */
#endif
);


