/*
 ******************************************************************************
 ******************************************************************************
 *****                             ctest.c                                *****
 *****									  *****
 *****	     Simple PEXtk Test Program for color switching   		  *****
 *****									  *****
 *****									  *****
 *                                                                            *
 *	Copyright 1992, 1993. All Rights Reserved                             *
 *			SHOgraphics					      *
 *			321 Soquel Way           			      *
 *			Sunnyvale, CA     94086   			      *
 *                                                                            *
 *****									  *****

    Permission to use, copy, modify, and distribute this software and
 its documentation for any purpose and without fee is hereby granted,
 provided that the above copyright notice appear in all copies and that
 both that copyright notice and this permission notice appear in
 supporting documentation, and that the name of SHOgraphics not be
 used in advertising or publicity pertaining to distribution of the 
 software without specific, written prior permission.

 SHOGRAPHICS DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 INCLUDING ALL EXPRESSED AND IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS. IN NO EVENT SHALL SHOGRAPHICS BE LIABLE FOR ANY DAMAGES OF ANY
 KIND, INCLUDING BUT NOT LIMITED TO SPECIAL, INDIRECT OR CONSEQUENTIAL 
 DAMAGES RESULTING FROM LOSS OF USE, DATA OR PROSPECTIVE PROFITS, WHETHER 
 IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS ACTION, ARISING OUT 
 OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

 ************************************************************************ 
 */
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include <stdio.h>
#include <PEXtk.h>

#include "include/Open_X_Window.c"
#include "read_demo_obj.c"

main (argc, argv)
int argc; char **argv;
{
    int i,j,k,m,n, win_width=500, win_height=500;
    Display 		 *dpy;
    Window 		 window;
    PEXtkCoord3D	 ctr, vt[256];
    PCOLOR		 colorObj, colorObjInv;
    float		 scale = 1.0;

    if( argc < 2 ){
	printf("Error...\nUsage: ctest file.obj [[z_trans] scale]\n");
	exit(1);
    }

    if ((dpy = XOpenDisplay ("")) == NULL) {
	printf(" Error opening display\n");
	return 1;
    }

    if(Pinit(dpy)){
	printf("ERROR... initializing PEX server\n");
	exit(1);
    }

    if( Open_X_Window(&dpy, &window, win_width, win_height)){
	printf("ERROR... creating window\n");
	exit(1);
    }
    if( argc > 2 ) z_trans_factor = atof(argv[2]);
    if( argc > 3 ) scale = atof(argv[3]);
    read_demo_obj( argv[1], &ctr, scale);

    Pset_drawable( window );
    Pbuffer_mode(  PEXtk_DOUBLE_BUFFER );
    Pviewport( 0, win_width-1, 0, win_height-1);
    Ppersp_view( 0, 90.0, 1.0, 1.0, 1000.0);

    colorObj.color.rgb.red   = 0.9; colorObj.color.rgb.green = 0.0;
    colorObj.color.rgb.blue  = 0.4;
    colorObjInv.color.rgb.red   = 0.4; colorObjInv.color.rgb.green = 0.0;
    colorObjInv.color.rgb.blue  = 0.9;
    Pcolor( &colorObj);

    Pcreate_struct(1);
	for(i=0,j=0; i<poly_cnt; i++)
	{
           k = vert_indices[j];
           for( m=0;m<facet_Count[i]; m++){
             n = vert_indices[j++];
             vt[m].x = verts[n].x; vt[m].y = verts[n].y; vt[m].z = verts[n].z;
	   }
	Ppoly_fill( m, vt);
	}
    Pclose_struct();

	Ptranslate( -ctr.x, -ctr.y, 0.0, 1);
    i=0;
    while(i < 200){
	Pclear_rgb( 0.0, 0.0, 0.0);
	if( (i/10) % 2 == 0 ){
	Pcolor_rgb( (float)(colorObj.color.rgb.red),
	    (float)(colorObj.color.rgb.green),
	    (float)(colorObj.color.rgb.blue));
	} else {
	Pcolor_rgb( (float)(colorObjInv.color.rgb.red),
	    (float)(colorObjInv.color.rgb.green),
	    (float)(colorObjInv.color.rgb.blue));
	}
	Protate_z( 3.0, 1 );
	Pexec_struct( 1);
	Pswap_buffers(); i++;
    }
    XCloseDisplay( dpy);
} 
