/*
 ******************************************************************************
 ******************************************************************************
 *****                             dtest.c                                *****
 *****									  *****
 *****		           Demo Program for PEXtk      			  *****
 *****									  *****
 *****									  *****
 *                                                                            *
 *	Copyright 1991, All Rights Reserved                                   *
 *			ShoGraphics					      *
 *			1890 North Shoreline Blvd			      *
 *			Mountain View, CA    94043			      *
 *                                                                            *
 *****									  *****

    Permission to use, copy, modify, and distribute this software and
 its documentation for any purpose and without fee is hereby granted,
 provided that the above copyright notice appear in all copies and that
 both that copyright notice and this permission notice appear in
 supporting documentation, and that the name of ShoGraphics not be
 used in advertising or publicity pertaining to distribution of the 
 software without specific, written prior permission.

 SHOGRAPHICS DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 INCLUDING ALL EXPRESSED AND IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS. IN NO EVENT SHALL SHOGRAPHICS BE LIABLE FOR ANY DAMAGES OF ANY
 KIND, INCLUDING BUT NOT LIMITED TO SPECIAL, INDIRECT OR CONSEQUENTIAL 
 DAMAGES RESULTING FROM LOSS OF USE, DATA OR PROSPECTIVE PROFITS, WHETHER 
 IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS ACTION, ARISING OUT 
 OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

 ************************************************************************ 
 */

#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include <stdio.h>
#include <PEXtk.h>

#include "include/Open_X_Window.c"
#include "read_demo_obj.c"

main (argc, argv)
int argc; char **argv;
{
    int i,j,k,m,n, win_width=500, win_height=500;
    Display 		 *dpy;
    Window 		 window;
    PEXtkCoord3D	 ctr, vt[256];
    float		 scale = 1.0;

    if( argc < 2 ){
	printf("Error...\nUsage: dtest file.obj [[ z_trans] scale ]\n");
	exit(1);
    }
    if( Open_X_Window(&dpy, &window, win_width, win_height)){
	printf("ERROR... opening display\n");
	exit(1);
    }

    if(Pinit(dpy)){
	printf("ERROR... initializing PEX server\n");
	exit(1);
    }
    if( argc > 2 ) z_trans_factor = atof(argv[2]);
    if( argc > 3 ) scale = atof(argv[3]);
    read_demo_obj( argv[1], &ctr, scale);

    Pset_drawable( window );
    Pbuffer_mode(  PEXtk_DOUBLE_BUFFER );
    Pviewport( 0, win_width-1, 0, win_height-1);
    Ppersp_view( 0, 90.0, 1.0, 1.0, 1000.0);

    Pline_color_rgb( 1.0, 0.0, 1.0);
    Pcolor_rgb( 1.0, 0.0, 1.0);

    Pcreate_struct(1);
	for(i=0,j=0; i<poly_cnt; i++)
	{
           k = vert_indices[j];
           for( m=0;m<facet_Count[i]; m++){
             n = vert_indices[j++];
             vt[m].x = verts[n].x; vt[m].y = verts[n].y; vt[m].z = verts[n].z;
	   }
             vt[m].x = verts[k].x; vt[m].y = verts[k].y; vt[m].z = verts[k].z;
	/* Ppoly_fill( m, vt); */
	Ppoly_line( m+1, vt);
	}
    Pclose_struct();

	Ptranslate( -ctr.x, -ctr.y, 0.0, 1);
	i = 200;
    while(i > 0){
	Pclear_rgb( 0.0, 0.0, 0.0);
	Protate_z( 3.0, 1 );
	Pexec_struct( 1);
	Pswap_buffers();
	/* sleep(1); */
	i--;
    }
	Pexit();
	XCloseDisplay( dpy);
} 
