/*
 ******************************************************************************
 ******************************************************************************
 *****                             PEXtk                                  *****
 *****									  *****
 *****		    An Immediate Mode Interface to PEX			  *****
 *****									  *****
 *****				Include file 				  *****
 *****									  *****
 *                                                                            *
 *	Copyright 1991, All Rights Reserved                                   *
 *			ShoGraphics					      *
 *			1890 North Shoreline Blvd			      *
 *			Mountain View, CA    94043			      *
 *                                                                            *
 *****									  *****

    Permission to use, copy, modify, and distribute this software and
 its documentation for any purpose and without fee is hereby granted,
 provided that the above copyright notice appear in all copies and that
 both that copyright notice and this permission notice appear in
 supporting documentation, and that the name of ShoGraphics not be
 used in advertising or publicity pertaining to distribution of the 
 software without specific, written prior permission.

 SHOGRAPHICS DISCLAIMS ANY AND ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 INCLUDING ALL EXPRESSED AND IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS. IN NO EVENT SHALL SHOGRAPHICS BE LIABLE FOR ANY DAMAGES OF ANY
 KIND, INCLUDING BUT NOT LIMITED TO SPECIAL, INDIRECT OR CONSEQUENTIAL 
 DAMAGES RESULTING FROM LOSS OF USE, DATA OR PROSPECTIVE PROFITS, WHETHER 
 IN AN ACTION OF CONTRACT, NEGLIENCE OR OTHER TORTIOUS ACTION, ARISING OUT 
 OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

 ************************************************************************ 
 *
 *	typedef for read_obj data
 *
 *	This structure contains all pertinant data found in an .obj file.
 */

typedef struct ObjData {
	int		file_type;
	int		flip_flag;
	Fcoord4D    	*verts;
	Fcoord3D    	*vertt, *vertn, *vertp;
	rgbFloat	*pcol;
	rgbFloat	*vcol;
	unsigned short  *vert_indices;	/* vertex coord's indicies */
	unsigned short  *vt_indices;	/* texture vertex indicies */
	unsigned short  *vn_indices;	/* vertex normals indicies */
	unsigned short  *vc_indices;	/* colors per vertex indicies */
	unsigned short  *facet_Count, *norm_Count, *clr_Count;
	int             poly_cnt, vct, vtct, vnct, vpct, numEdges;
        int		vcct, pcct, numNorms;
	int		max_index;	/* max number of 'edges' or indicies*/
	int		max_cnt;	/* max number of facet Counts */
	Fcoord3D 	ctr;
	Fcoord3D 	global_pos;
	Fcoord3D 	global_min;
	Fcoord3D 	global_max;
	float		z_trans;
	float		r,g,b;
	int		mask;
	char		string[132];
	int		i_value;	/* misc. int value */
	float		f_value;	/* misc. float value */

	short	ptype;			/* the parametric type of element,*/
					/*    specified in cstype stmt */
	short	ratnl;			/* true if rational, false if non-rat*/
					/*    specified in cstype stmt */
	int	deg_u;			/* degree in u of parametric element */
					/*    specified in deg statement */
	int	deg_v;			/* degree in v of parametric element */
					/*    specified in deg statement */
	int	nparm_u;		/* number of items in parm_u */
	int	size_parm_u;		/* size of buffer for parm_u */
	float	*parm_u;		/* values given in parm u stmt */
	int	nparm_v;		/* number of items in parm_v */
	int	size_parm_v;		/* size of buffer for parm_v */
	float	*parm_v;		/* values given in parm v stmt */
	float   umin, umax;
	float   vmin, vmax;

	} ObjData;
	
